/****************************************************************
* MENU.C - generalized menu handler subroutine					*
*																*
* INP:	m - menu descriptor										*
* OUT:	0 (if escape key was pressed), or # of chosen selection	*
* NOTE:	No error checking is performed during display			*
****************************************************************/

#include <stdio.h>	// fputc(), stderr
#include <stdlib.h>	// atoi()
#include <string.h>	// strncmp()
#include <conio.h>	// cputs()
#include <graph.h>	// _clearscreen(), _setbkcolor(), ...
#include "menu.h"	// menu()

/* Count the number of DELIM characters in the input string */
int Dcount(char *s)
	{
	int r;

	for (r=0; *s != '\0'; s++)
		if (*s == '\1')
			++r;
	return r;
	}

/* Find number of characters in string to string end or DELIM */
int Dstrlen(char *s)
	{
	int r;

	for (r=0; *s && *s!='\1'; r++,s++)
		;
	return r;
	}

/* Write string (terminated by EOS or DELIM) to console */
void Dcputs(char *s)
	{
	static char buf[80];
	int cnt;

	for (cnt=0 ; *s && *s!='\1'; s++)
		buf[cnt++]=*s;
	buf[cnt]=0;
	_outtext(buf);
	}

/* Clear the specified row */
void clearRow(int row)
	{
	_settextposition(row,1);
	_outtext("                                        "
			 "                                       ");
	_settextposition(row,1);
	}

int menu(MENU *m)
	{
	int  hc, tc, cc, i, max, tmp;
	char *t, rsp[CRT_WIDTH-26+2];

	_setbkcolor(BLUE);
	_clearscreen(_GCLEARSCREEN);

	/* Count heading lines, text lines & choices*/
	hc = Dcount(m->hdr)+1;
	tc = Dcount(m->text)+1;
	cc = Dcount(m->choice)+1;

	/* Draw the heading */
	_settextcolor(YELLOW);
	for (i=0,t=m->hdr; i<hc; i++)
		{
		_settextposition(i+1,(CRT_WIDTH-Dstrlen(t))/2);
		Dcputs(t);
		t+=Dstrlen(t)+1;
		}

	/* Draw the text lines */
	_settextcolor(BRIGHT_WHITE);
	for (i=0,t=m->text,max=0; i<tc; i++)
		{
		tmp = Dstrlen(t);
		if (tmp > max) max=tmp;
		t += tmp+1;
		}
	tmp = (CRT_PRMPT-hc-tc)/2 + hc;
	for (i=0,t=m->text; i<tc; i++)
		{
		_settextposition(i+tmp,(CRT_WIDTH-max)/2);
		Dcputs(t);
		t+=Dstrlen(t)+1;
		}

	/* Find length of maximum response */
	for (i=0,t=m->choice,max=0; i<cc; i++)
		{
		tmp = Dstrlen(t);
		if (tmp > max) max=tmp;
		t += tmp+1;
		}
	if (max>CRT_WIDTH-26) max=CRT_WIDTH-26;
	if (max<5) max=5;
	rsp[0] = (char)max;

	for (tmp=-1; tmp<0; )
		{
		/* Get the user's response */
		_settextcolor(YELLOW);
		clearRow(24);
		_outtext("Please enter your choice: ");
		cgets(rsp);

		/* Check if response is valid */
		for (i=0,t=m->choice,max=0; i<cc; i++)
			{
			if (!strncmp(rsp+2,t,rsp[1]))
				tmp=i;
			t += Dstrlen(t)+1;
			}
		clearRow(25);
		if (tmp < 0)
			{			/* Nope ... invalid */
			_settextcolor(BLINK+LT_RED);
			_outtext(rsp+2);
			_outtext(" is not a legal choice!");
			fputc('\7',stderr);
			}
		}

	/* Return the appropriate value */
	for (i=0,t=m->response; i<cc; i++)
		{
		if (i==tmp)
			{
			tmp=atoi(t);
			i=cc+1;
			}
		t += Dstrlen(t)+1;
		}
	return tmp;
	}
