/****************************************************************
* MAKEDBF.C - Create the NEWPLAN.DBF file from PLANETS.DBF		*
****************************************************************/

#include <io.h>		// access()
#include <stdio.h>	// fclose(), FILE, puts()
#include <stdlib.h>	// exit()
#include "dbase.h"	// dbfFILE, dbfCreate(), dbfDispStru(), ...

void main(void)
	{
	dbfFILE  DBF;
	FILE	*outf;

	// If the layout file does not exist, create it from PLANETS
	//
	if (access("newplan.lay",0))
		{
		puts("Creating NEWPLAN.LAY from PLANETS.DBF");
		DBF=dbfOpen("planets.dbf");
		outf = fopen("newplan.lay","w");
		if (!outf)
			{
			puts("Can't open NEWPLAN.LAY for output");
			exit(1);
			}
		dbfDispStru(DBF,outf);
		fclose(outf);
		dbfClose(DBF);
		}

	// Create a dbase file from the layout file
	//
	puts("Reading structure from NEWPLAN.LAY");
	DBF = dbfInputStr("newplan.lay");
	if (!DBF)
		{
		puts("Either we couldn't read NEWPLAN.LAY, or we "
			 "had an error\ntrying to allocate RAM.");
		exit(1);
		}
	puts("Creating NEWPLAN.DBF from structure");
	if (dbfCreate(DBF,"newplan.dbf"))
		puts("We couldn't create NEWPLAN.DBF");
	}
